<?php
	include("../../../config.php");
	include("../../../scripts/functions.php");

	$type = $_GET['type'];
	$path = $_GET['path'];
	$maxInterval = $_GET['interval'];
	$path = urldecode($path);

	include("settings.php");

	if($type=="mb"){
		if(file_exists("../../../plugins/liveGaugesMB/mbLive.txt")){
			$current['DateTime'] = filemtime("../../../plugins/liveGaugesMB/mbLive.txt");
		}
	}

	if($prefferedTime=="12h"){
		$updateTimeFormat = "g:i:s A";
	}
	else{
		$updateTimeFormat = "G:i:s";
	}
	// use API
	if($type=="api"){
		$apiData = file_get_contents("../../../meteotemplateLive.txt");
		$apiData = json_decode($apiData,true);
		$current['T'] = number_format(convertor($apiData['T'],"C",$displayTempUnits),1,".","");
		$current['H'] = number_format($apiData['H'],1,".","");
		if($displayPressUnits=="hpa"){
			$current['P'] = number_format(convertor($apiData['P'],"hpa",$displayPressUnits),1,".","");
		}
		else{
			$current['P'] = number_format(convertor($apiData['P'],"hpa",$displayPressUnits),2,".","");
		}
		$current['W'] = number_format(convertor($apiData['W'],"kmh",$displayWindUnits),1,".","");
		$current['G'] = number_format(convertor($apiData['G'],"kmh",$displayWindUnits),1,".","");
		if($displayRainUnits=="mm"){
			$current['R'] = number_format(convertor($apiData['R'],"mm",$displayRainUnits),1,".","");
		}
		else{
			$current['R'] = number_format(convertor($apiData['R'],"mm",$displayRainUnits),2,".","");
		}
		$current['D'] = number_format(convertor($apiData['D'],"C",$displayTempUnits),1,".","");
		$current['A'] = number_format(convertor($apiData['A'],"C",$displayTempUnits),1,".","");
		$current['B'] = $apiData['B'];
		$current['S'] = round($apiData['S'],0);
		if(isset($apiData['UV'])){
			$current['UV'] = $apiData['UV'];
		}
		else{
			$current['UV'] = "";
		}
		$current['DateTime'] = $apiData['U'];
		$current['Timestamp'] = date($updateTimeFormat,$apiData['U']);
	}

	// update from database
	if($type=="db"){
		$result = mysqli_query($con,"
			SELECT DateTime,T,H,P,W,G,A,D,S,R,B
			FROM alldata
			ORDER BY DateTime DESC
			LIMIT 1
			"
		);
		while($row = mysqli_fetch_array($result)){
			$current['T'] = number_format(convertT($row['T']),1,".","");
			$current['H'] = number_format($row['H'],1,".","");
			if($displayPressUnits=="hpa"){
				$current['P'] = number_format(convertP($row['P']),1,".","");
			}
			else{
				$current['P'] = number_format(convertP($row['P']),2,".","");
			}
			$current['W'] = number_format(convertW($row['W']),1,".","");
			$current['G'] = number_format(convertW($row['G']),1,".","");
			if($displayRainUnits=="mm"){
				$current['R'] = number_format(convertR($row['R']),1,".","");
			}
			else{
				$current['R'] = number_format(convertR($row['R']),2,".","");
			}
			$current['D'] = number_format(convertT($row['D']),1,".","");
			$current['A'] = number_format(convertT($row['A']),1,".","");
			$current['B'] = $row['B'];
			$current['S'] = $row['S'];
			$current['UV'] = "";
			$current['DateTime'] = strtotime($row['DateTime']);
			$current['Timestamp'] = date($updateTimeFormat,strtotime($row['DateTime']));
		}
	}

	// update from database from WL
	if($type=="wl"){
		$result = mysqli_query($con,"
			SELECT DateTime,T,H,P,W,G,A,D,S,R,B
			FROM alldata
			ORDER BY DateTime DESC
			LIMIT 1
			"
		);
		while($row = mysqli_fetch_array($result)){
			$current['T'] = number_format(convertT($row['T']),1,".","");
			$current['H'] = number_format($row['H'],1,".","");
			if($displayPressUnits=="hpa"){
				$current['P'] = number_format(convertP($row['P']),1,".","");
			}
			else{
				$current['P'] = number_format(convertP($row['P']),2,".","");
			}
			$current['W'] = number_format(convertW($row['W']),1,".","");
			$current['G'] = number_format(convertW($row['G']),1,".","");
			if($displayRainUnits=="mm"){
				$current['R'] = number_format(convertR($row['R']),1,".","");
			}
			else{
				$current['R'] = number_format(convertR($row['R']),2,".","");
			}
			$current['D'] = number_format(convertT($row['D']),1,".","");
			$current['A'] = number_format(convertT($row['A']),1,".","");
			$current['B'] = $row['B'];
			$current['S'] = $row['S'];
			if(file_exists("../../../plugins/wlIP/UV.txt")){
				$current['UV'] = file_get_contents("../../../plugins/wlIP/UV.txt");
			}
			else{
				$current['UV'] = "";
			}
			$current['DateTime'] = strtotime($row['DateTime']);
			$current['Timestamp'] = date($updateTimeFormat,strtotime($row['DateTime']));
		}
	}

	// update from clientraw
	if($type=="wd"){
		// set units for wd
		$dataTempUnits = "C";
		$dataWindUnits = "kt";
		$dataRainUnits = "mm";
		$dataPressUnits = "hpa";
		$clientraw = file_get_contents($path);
		$clientrawData = explode(" ",$clientraw);

		$current['T'] = number_format(convertT($clientrawData[4]),1,".","");
		$current['H'] = number_format($clientrawData[5],1,".","");
		if($displayPressUnits=="hpa"){
			$current['P'] = number_format(convertP($clientrawData[6]),1,".","");
		}
		else{
			$current['P'] = number_format(convertP($clientrawData[6]),2,".","");
		}
		$current['W'] = number_format(convertW($clientrawData[1]),1,".","");
		$current['G'] = number_format(convertW($clientrawData[2]),1,".","");
		if($displayRainUnits=="mm"){
			$current['R'] = number_format(convertR($clientrawData[7]),1,".","");
		}
		else{
			$current['R'] = number_format(convertR($clientrawData[7]),2,".","");
		}
		$current['D'] = number_format(convertT($clientrawData[72]),1,".","");
		$apparentT = apparentWD($clientrawData[4],$clientrawData[5],($clientrawData[1]*0.514444));
		$current['A'] = number_format(convertT($apparentT),1,".","");
		$current['B'] = $clientrawData[3];
		$current['S'] = $clientrawData[127];
		$current['UV'] = $clientrawData[79];
		$dateStringFormatted = $clientrawData[141]."-".$clientrawData[36]."-".$clientrawData[35];
		$current['Timestamp'] = date($updateTimeFormat,strtotime("2015-1-1 ".$clientrawData[29].":".$clientrawData[30].":".$clientrawData[31]));
		$current['DateTime'] = strtotime($dateStringFormatted." ".$clientrawData[29].":".$clientrawData[30].":".$clientrawData[31]);
	}

	// update from Cumulus realtime.txt
	if($type=="cumulus"){
		$realtime = file_get_contents($path);
		$realtimeData = explode(" ",$realtime);
		// damn Cumulus is of course not standardized... get units
		$dataTempUnits = $realtimeData[14];
		$unitsW = $realtimeData[13];
		$dataRainUnits = $realtimeData[16];
		$unitsP = $realtimeData[15];
		// convert to Meteotemplate format
		if($unitsW=="m/s"){
			$dataWindUnits = "ms";
		}
		else if($unitsW=="km/h"){
			$dataWindUnits = "kmh";
		}
		else if($unitsW=="kts"){
			$dataWindUnits = "kt";
		}
		else{
			$dataWindUnits = "mph";
		}
		if($unitsP=="mb"){
			$dataPressUnits = "hpa";
		}
		else if($unitsP=="hPa"){
			$dataPressUnits = "hpa";
		}
		else{
			$dataPressUnits = "inhg";
		}

		$current['T'] = number_format(convertT($realtimeData[2]),1,".","");
		$current['H'] = number_format($realtimeData[3],1,".","");
		if($displayPressUnits=="hpa"){
			$current['P'] = number_format(convertP($realtimeData[10]),1,".","");
		}
		else{
			$current['P'] = number_format(convertP($realtimeData[10]),2,".","");
		}
		$current['W'] = number_format(convertW($realtimeData[6]),1,".","");
		$current['G'] = number_format(convertW($realtimeData[40]),1,".","");
		if($displayRainUnits=="mm"){
			$current['R'] = number_format(convertR($realtimeData[9]),1,".","");
		}
		else{
			$current['R'] = number_format(convertR($realtimeData[9]),2,".","");
		}
		$current['D'] = number_format(convertT($realtimeData[4]),1,".","");
		$current['A'] = number_format(convertT($realtimeData[54]),1,".","");
		$current['B'] = $realtimeData[7];
		$current['S'] = $realtimeData[45];
		$current['UV'] = $realtimeData[43];
		$current['Timestamp'] = date($updateTimeFormat,strtotime("2015-1-1 ".$realtimeData[1]));
		$dateSplit = explode("-",$realtimeData[0]);
		if(count($dateSplit)<2){
			$dateSplit = explode("/",$realtimeData[0]);
		}
		$current['DateTime'] = strtotime(($dateSplit[2]+2000)."-".$dateSplit[1]."-".$dateSplit[0]." ".$realtimeData[1]);
	}

	if($type=="mb"){
		// set units for mb
		$dataTempUnits = "C";
		$dataWindUnits = "kt";
		$dataRainUnits = "mm";
		$dataPressUnits = "hpa";
		$mbLive = file_get_contents($path);
		$mbLiveData = explode(";",$mbLive);

		$current['T'] = number_format(convertT($mbLiveData[0]),1,".","");
		$current['H'] = number_format($mbLiveData[1],1,".","");
		if($displayPressUnits=="hpa"){
			$current['P'] = number_format(convertP($mbLiveData[2]),1,".","");
		}
		else{
			$current['P'] = number_format(convertP($mbLiveData[2]),2,".","");
		}
		$current['W'] = number_format(convertW($mbLiveData[4]),1,".","");
		$current['G'] = number_format(convertW($mbLiveData[5]),1,".","");
		if($displayRainUnits=="mm"){
			$current['R'] = number_format(convertR($mbLiveData[9]),1,".","");
		}
		else{
			$current['R'] = number_format(convertR($mbLiveData[9]),2,".","");
		}
		$current['D'] = number_format(convertT($mbLiveData[7]),1,".","");
		$current['A'] = number_format(convertT($mbLiveData[13]),1,".","");
		$current['B'] = $mbLiveData[6];
		$current['S'] = $mbLiveData[8];
		$current['UV'] = $mbLiveData[15];
		$current['Timestamp'] = date($updateTimeFormat,strtotime("2015-1-1 ".$mbLiveData[16]));

	}

	if($type=="ws1001"){
		// set units for ws1001
		$dataTempUnits = "F";
		$dataWindUnits = "mph";
		$dataRainUnits = "in";
		$dataPressUnits = "inhg";
		$jsonFile = file_get_contents($path);
		$jsonData = json_decode($jsonFile,true);

		$current['T'] = number_format(convertT($jsonData['outsideTemp']),1,".","");
		$current['H'] = number_format($jsonData['outsideHumidity'],1,".","");
		if($displayPressUnits=="hpa"){
			$current['P'] = number_format(convertP($jsonData['barometer']),1,".","");
		}
		else{
			$current['P'] = number_format(convertP($jsonData['barometer']),2,".","");
		}
		$current['W'] = number_format(convertW($jsonData['windSpeed']),1,".","");
		$current['G'] = number_format(convertW($jsonData['windGust']),1,".","");
		if($displayRainUnits=="mm"){
			$current['R'] = number_format(convertR($jsonData['raintoday']),1,".","");
		}
		else{
			$current['R'] = number_format(convertR($jsonData['raintoday']),2,".","");
		}
		$current['D'] = number_format(convertT($jsonData['dewpoint']),1,".","");
		$apparentT = apparent($jsonData['outsideTemp'],$jsonData['outsideHumidity'],($jsonData['windSpeed']*0.44704));
		$current['A'] = number_format(convertT($apparentT),1,".","");
		$current['B'] = $jsonData['windDir'];
		$current['S'] = $jsonData['radiation'];
		$current['UV'] = $jsonData['UV'];
		$current['Timestamp'] = date($updateTimeFormat,$jsonData['timestamp']);
		$current['DateTime'] = $jsonDate['timestamp'];
	}

	if($type=="weatherCat"){
		$dateTimeZone = new DateTimeZone($stationTZ);
		$dateTime = new DateTime("now", $dateTimeZone);
		$offset = $dateTimeZone->getOffset($dateTime);
		$realtimeMT = explode("###",file_get_contents($path));
		$temporaryUTC = explode("|",$realtimeMT[0]);
		$temporaryUTC2 = explode(",",$temporaryUTC[1]);
		$temporaryTimestamp = strtotime($temporaryUTC2[0]."-".$temporaryUTC2[1]."-".$temporaryUTC2[2]." ".$temporaryUTC2[3].":".$temporaryUTC2[4].":".$temporaryUTC2[5])+$offset;
		$current['Timestamp'] = date($updateTimeFormat,$temporaryTimestamp);
		$current['DateTime'] = $temporaryTimestamp;
		for($a=0;$a<count($realtimeMT);$a++){
			$splitRow = explode("|",$realtimeMT[$a]);
			$key = $splitRow[0];
			$keyValue = str_replace(",",".",$splitRow[1]);
			$cleanDataArr[trim($key)] = trim($keyValue);
		}
		$currentT = $cleanDataArr['T'];
		$currentH = $cleanDataArr['H'];
		$currentP = $cleanDataArr['P'];
		$currentW = $cleanDataArr['W'];
		$currentG = $cleanDataArr['G'];
		$currentR = $cleanDataArr['R'];
		$currentRR = $cleanDataArr['RR'];
		$currentB = $cleanDataArr['B'];
		$currentS = $cleanDataArr['S'];
		$currentUV = $cleanDataArr['UV'];

		if (strpos($cleanDataArr['unitsT'], 'C') !== false) {
			$fileTempUnits = "C";
			$currentTC = $currentT;
		}
		else if (strpos($cleanDataArr['unitsT'], 'F') !== false) {
			$fileTempUnits = "F";
			$currentTC = ($currentT - 32)/1.8;
		}
		else{
			$fileTempUnits = "C";
		}
		$filePressUnits = strtolower($cleanDataArr['unitsP']);
		$fileRainUnits = strtolower($cleanDataArr['unitsR']);
		$fileWindUnits = strtolower($cleanDataArr['unitsW']);
		if($displayTempUnits=="F" && $fileTempUnits=="C"){
			$currentT = round(($currentT * 1.8) + 32,1);
		}
		if($displayTempUnits=="C" && $fileTempUnits=="F"){
			$currentT = round(($currentT -32) / 1.8,1);
		}
		if($filePressUnits=="inhg" && $displayPressUnits=="hpa"){
			$currentP = round($currentP * 33.86,1);
		}
		if($filePressUnits=="inhg" && $displayPressUnits=="mmhg"){
			$currentP = round($currentP * 25.39,1);
		}
		if($filePressUnits=="hpa" && $displayPressUnits=="inhg"){
			$currentP = round($currentP * 0.02952,2);
		}
		if($filePressUnits=="hpa" && $displayPressUnits=="mmhg"){
			$currentP = round($currentP * 0.75,1);
		}
		if($filePressUnits=="mbar" && $displayPressUnits=="inhg"){
			$currentP = round($currentP * 0.02952,2);
		}
		if($filePressUnits=="mbar" && $displayPressUnits=="mmhg"){
			$currentP = round($currentP * 0.75,1);
		}
		if($filePressUnits=="mb" && $displayPressUnits=="inhg"){
			$currentP = round($currentP * 0.02952,2);
		}
		if($filePressUnits=="mb" && $displayPressUnits=="mmhg"){
			$currentP = round($currentP * 0.75,1);
		}

		if($fileWindUnits=="km/h"){
			$currentWMS = $currentW/3.6;
		}
		if($fileWindUnits=="m/s"){
			$currentWMS = $currentW;
		}
		if($fileWindUnits=="knots"){
			$currentWMS = $currentW* 0.514444;
		}
		if($fileWindUnits=="mph"){
			$currentWMS = $currentW* 0.44704;
		}

		if($displayWindUnits=="kmh" && $fileWindUnits=="km/h"){
			$currentW = round($currentW * 1,1);
			$currentG = round($currentG * 1,1);

		}
		if($displayWindUnits=="kmh" && $fileWindUnits=="m/s"){
			$currentW = round($currentW * 3.6,1);
			$currentG = round($currentG * 3.6,1);
		}
		if($displayWindUnits=="kmh" && $fileWindUnits=="knots"){
			$currentW = round($currentW * 1.852,1);
			$currentG = round($currentG * 1.852,1);
		}
		if($displayWindUnits=="kmh" && $fileWindUnits=="mph"){
			$currentW = round($currentW * 1.60934,1);
			$currentG = round($currentG * 1.60934,1);
		}
		if($displayWindUnits=="ms" && $fileWindUnits=="km/h"){
			$currentW = round($currentW / 3.6,1);
			$currentG = round($currentG / 3.6,1);
		}
		if($displayWindUnits=="ms" && $fileWindUnits=="m/s"){
			$currentW = round($currentW * 1,1);
			$currentG = round($currentG * 1,1);
		}
		if($displayWindUnits=="ms" && $fileWindUnits=="knots"){
			$currentW = round($currentW * 0.514444,1);
			$currentG = round($currentG * 0.514444,1);
		}
		if($displayWindUnits=="ms" && $fileWindUnits=="mph"){
			$currentW = round($currentW * 0.44704,1);
			$currentG = round($currentG * 0.44704,1);
		}
		if($displayWindUnits=="mph" && $fileWindUnits=="km/h"){
			$currentW = round($currentW * 0.621371,1);
			$currentG = round($currentG * 0.621371,1);
		}
		if($displayWindUnits=="mph" && $fileWindUnits=="m/s"){
			$currentW = round($currentW * 2.23694,1);
			$currentG = round($currentG * 2.23694,1);
		}
		if($displayWindUnits=="mph" && $fileWindUnits=="knots"){
			$currentW = round($currentW * 1.15078,1);
			$currentG = round($currentG * 1.15078,1);
		}
		if($displayWindUnits=="mph" && $fileWindUnits=="mph"){
			$currentW = round($currentW * 1,1);
			$currentG = round($currentG * 1,1);
		}

		if($displayRainUnits=="in" && $fileRainUnits=="mm"){
			$currentR = round($currentR / 25.4,2);
			$currentRR = round($currentRR / 25.4,2);
		}
		if($displayRainUnits=="mm" && $fileRainUnits=="in"){
			$currentR = round($currentR * 25.4,1);
			$currentRR = round($currentRR * 25.4,1);
		}
		$current['T'] = number_format($currentT,1,".","");
		$current['H'] = number_format($currentH,1,".","");
		if($displayPressUnits=="hpa"){
			$current['P'] = number_format($currentP,1,".","");
		}
		else{
			$current['P'] = number_format($currentP,2,".","");
		}
		$current['W'] = number_format($currentW,1,".","");
		$current['G'] = number_format($currentG,1,".","");
		if($displayRainUnits=="mm"){
			$current['R'] = number_format($currentR,1,".","");
		}
		else{
			$current['R'] = number_format($currentR,2,".","");
		}
		$currentA = apparentWeatherCat($currentTC, $currentH, $currentWMS);
		$currentD = dewpointWeatherCat($currentTC, $currentH);
		if($displayTempUnits=="F"){
			$currentA = $currentA*1.8 + 32;
			$currentD = $currentD*1.8 + 32;
		}
		$current['D'] = number_format($currentD,1,".","");
		$current['A'] = number_format($currentA,1,".","");
		$current['B'] = $currentB;
		$current['S'] = $currentS;
		$current['UV'] = $currentUV;
	}

	// rain rate is calculated and reported differently by various SW, so we use db value for all
	$result = mysqli_query($con,"
		SELECT RR
		FROM alldata
		ORDER BY DateTime DESC
		LIMIT 1
		"
	);
	while($row = mysqli_fetch_array($result)){
		if($displayRainUnits=="mm"){
			$current['RR'] = number_format(convertR($row['RR']),1,".","");
		}
		else{
			$current['RR'] = number_format(convertR($row['RR']),2,".","");
		}
	}

	$temporaryBft = getBft(convertor($current['W'],$displayWindUnits,'ms'));
	$current['WBft'] = $temporaryBft[0];
	$current['WBftBg'] = $temporaryBft[1];
	$current['WBftColor'] = $temporaryBft[2];

	$temporaryBft = getBft(convertor($current['G'],$displayWindUnits,'ms'));
	$current['GBft'] = $temporaryBft[0];
	$current['GBftBg'] = $temporaryBft[1];
	$current['GBftColor'] = $temporaryBft[2];

	// trends
	if($currentShowTrends){
		$result = mysqli_query($con, "
			SELECT  T, H, P, W, G, A, D
			FROM  alldata
			WHERE DateTime >= now() - interval ".$currentTrendInterval." hour
			ORDER BY DateTime
			"
		);
		while ($row = mysqli_fetch_array($result)) {
			$trendTs[] = convertT($row['T']);
			$trendHs[] = ($row['H']);
			$trendPs[] = convertP($row['P']);
			$trendWs[] = convertW($row['W']);
			$trendGs[] = convertW($row['G']);
			$trendAs[] = convertT($row['A']);
			$trendDs[] = convertT($row['D']);
		}

		// temperature, humidity, pressure, feels like, dew point - compare latest with hour ago
		if(isset($trendTs)){
			$trendT = $trendTs[(count($trendTs)-1)] - $trendTs[0];
		}
		if(isset($trendHs)){
			$trendH = $trendHs[(count($trendHs)-1)] - $trendHs[0];
		}
		if(isset($trendPs)){
			$trendP = $trendPs[(count($trendPs)-1)] - $trendPs[0];
		}
		if(isset($trendAs)){
			$trendA = $trendAs[(count($trendAs)-1)] - $trendAs[0];
		}
		if(isset($trendDs)){
			$trendD = $trendDs[(count($trendDs)-1)] - $trendDs[0];
		}

		// wind - calculate average from first half hour, compare with avg from latest half hour
		if(isset($trendWs)){
			$trendIntervals = floor(count($trendWs)/2);
			for($i=0;$i<$trendIntervals;$i++){
				$trendW1[] = $trendWs[$i];
				$trendG1[] = $trendGs[$i];
			}
			for($i=$trendIntervals;$i<count($trendWs);$i++){
				$trendW2[] = $trendWs[$i];
				$trendG2[] = $trendGs[$i];
			}

			$trendW = array_sum($trendW2)/count($trendW2) - array_sum($trendW1)/count($trendW1);
			$trendG = array_sum($trendG2)/count($trendG2) - array_sum($trendG1)/count($trendG1);
		}
		if(isset($trendT)){
			$current['trendT'] = getTrend($trendT,"T");
		}
		else{
			$current['trendT'] = "";
		}
		if(isset($trendH)){
			$current['trendH'] = getTrend($trendH,"H");
		}
		else{
			$current['trendH'] = "";
		}
		if(isset($trendP)){
			$current['trendP'] = getTrend($trendP,"P");
		}
		else{
			$current['trendP'] = "";
		}
		if(isset($trendW)){
			$current['trendW'] = getTrend($trendW,"W");
		}
		else{
			$current['trendW'] = "";
		}
		if(isset($trendG)){
			$current['trendG'] = getTrend($trendG,"G");
		}
		else{
			$current['trendG'] = "";
		}
		if(isset($trendA)){
			$current['trendA'] = getTrend($trendA,"A");
		}
		else{
			$current['trendA'] = "";
		}
		if(isset($trendD)){
			$current['trendD'] = getTrend($trendD,"D");
		}
		else{
			$current['trendD'] = "";
		}
	}

	function apparent($T,$H,$W){
		$T = ($T-32)/1.8;
		$e = ($H/100)*6.105*pow(2.71828, ((17.27*$T)/(237.7+$T)));
		$A = round(($T + 0.33*$e-0.7*$W-4),1);
		$A = ($A*1.8)+32;
		return $A;
	}
	function apparentWeatherCat($T,$H,$W){
		$e = ($H/100)*6.105*pow(2.71828, ((17.27*$T)/(237.7+$T)));
		$A = round(($T + 0.33*$e-0.7*$W-4),1);
		return $A;
	}
	function apparentWD($T,$H,$W){
		$e = ($H/100)*6.105*pow(2.71828, ((17.27*$T)/(237.7+$T)));
		$A = round(($T + 0.33*$e-0.7*$W-4),1);
		return $A;
	}
	function dewpointWeatherCat($T,$H){
		$D = round(((pow(($H/100), 0.125))*(112+0.9*$T)+(0.1*$T)-112),1);
		return $D;
	}
	function dewpoint($T,$H){
		$D = round(((pow(($H/100), 0.125))*(112+0.9*$T)+(0.1*$T)-112),1);
		return $D;
	}
	function getBft($input){
		if($input<0.3){
			return array(0,"#ffffff","#000");
		}
		if($input>=0.3 && $input<1.5){
			return array(1,"#CCFFFF","#000");
		}
		if($input>=1.5 && $input<3.3){
			return array(2,"#99FFCC","#000");
		}
		if($input>=3.3 && $input<5.5){
			return array(3,"#99FF99","#000");
		}
		if($input>=5.5 && $input<8){
			return array(4,"#99FF66","#000");
		}
		if($input>=8 && $input<10.8){
			return array(5,"#99FF00","#000");
		}
		if($input>=10.8 && $input<13.9){
			return array(6,"#CCFF00","#000");
		}
		if($input>=13.9 && $input<17.2){
			return array(7,"#FFFF00","#000");
		}
		if($input>=17.2 && $input<20.7){
			return array(8,"#FFCC00","#000");
		}
		if($input>=20.7 && $input<24.5){
			return array(9,"#FF9900","#000");
		}
		if($input>=24.5 && $input<28.4){
			return array(10,"#FF6600","#000");
		}
		if($input>=28.4 && $input<32.6){
			return array(11,"#FF3300","#000");
		}
		if($input>=32.6){
			return array(12,"#FF0000","#000");
		}
	}
	function getTrend($trend,$parameter){
		global $displayWindUnits;
		global $displayPressUnits;
		if($parameter=="T" || $parameter=="A" || $parameter=="D"){
			if($trend<-0.5){
				return "<span class='mticon-trenddown' style='font-size:1.3em'></span>";
			}
			else if($trend>0.5){
				return "<span class='mticon-trendup' style='font-size:1.3em'></span>";
			}
			else{
				return "<span class='mticon-trendneutral' style='font-size:1.3em'></span>";
			}
		}
		if($parameter=="H"){
			if($trend<-3){
				return "<span class='mticon-trenddown' style='font-size:1.3em'></span>";
			}
			else if($trend>3){
				return "<span class='mticon-trendup' style='font-size:1.3em'></span>";
			}
			else{
				return "<span class='mticon-trendneutral' style='font-size:1.3em'></span>";
			}
		}
		if($parameter=="W" || $parameter=="G"){
			if($displayWindUnits=="ms"){
				if($trend<-1.5){
					return "<span class='mticon-trenddown' style='font-size:1.3em'></span>";
				}
				else if($trend>1.5){
					return "<span class='mticon-trendup' style='font-size:1.3em'></span>";
				}
				else{
					return "<span class='mticon-trendneutral' style='font-size:1.3em'></span>";
				}
			}
			else{
				if($trend<-5){
					return "<span class='mticon-trenddown' style='font-size:1.3em'></span>";
				}
				else if($trend>5){
					return "<span class='mticon-trendup' style='font-size:1.3em'></span>";
				}
				else{
					return "<span class='mticon-trendneutral' style='font-size:1.3em'></span>";
				}
			}
		}
		if($parameter=="P"){
			if($displayPressUnits=="hpa"){
				if($trend<-0.5){
					return "<span class='mticon-trenddown' style='font-size:1.3em'></span>";
				}
				else if($trend>0.5){
					return "<span class='mticon-trendup' style='font-size:1.3em'></span>";
				}
				else{
					return "<span class='mticon-trendneutral' style='font-size:1.3em'></span>";
				}
			}
			else{
				if($trend<-0.05){
					return "<span class='mticon-trenddown' style='font-size:1.3em'></span>";
				}
				else if($trend>0.05){
					return "<span class='mticon-trendup' style='font-size:1.3em'></span>";
				}
				else{
					return "<span class='mticon-trendneutral' style='font-size:1.3em'></span>";
				}
			}
		}
	}
	$offlineTime = time() - $maxInterval*60;
	if($offlineTime>$current['DateTime']){
		$current['offline'] = 1;
	}
	else{
		$current['offline'] = 0;
	}
	$current['dt'] = date($dateTimeFormat,$current['DateTime']);
	$current = json_encode($current,JSON_NUMERIC_CHECK);
	echo $current;
?>
